/* $Id: checklist.c,v 1.2 2000/10/10 22:10:44 dps Exp $ */
/* Check a for one of a list of strings */
#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif /* HAVE_CONFIG_H */
#ifdef HAVE_ALLOCA_H
#include <alloca.h>
#endif /* HAVE_ALLOCA_H */
#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif /* HAVE_STDIO_H */
#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif /* HAVE_STDLIB_H */#
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */

#include "detail.h"

int check_list(FILE *in, const char *const *p, int n)
{
    char *buf;
    int i, max;

    for (max=0, i=0; i<n; i++)
    {
	if (strlen(*(p+i))>max)
	    max=strlen(*(p+i));
    }
    if ((buf=alloca(max+2))==NULL)
	return 0;
    if (get_string(in, buf, max+2)==-1)
	return 0;
    for (i=0; i<n; i++)
    {
	if (strcmp(buf, *(p+i))==0)
	    return i+1;
    }
    return 0;
}
    
