/* $Id: socklst.c,v 1.2 2000/10/10 22:10:44 dps Exp $ */


/* Zap socket list */
void socklist_zap(socklist *l)
{
    socklist *n;
    sockref *r, *nr;

    while (l!=NULL)
    {
	if (l->src!=NULL)
	    free((void *) l->src);
	if (l->dest!=NULL)
	    free((void *) l->dest);
	r=l->refs;
	while (r!=NULL)
	{
	    nr=r->next;
	    free((void *) r);
	    r=nr;
	}
	n=l->next;
	free((void *) l);
	l=n;
    }
}

/* Free a socket */
void free_sock(struct __sock_list *sp)
{
    sockref *r, *nr;

    if (sp->src!=NULL)
	free((void *) sp->src);
    if (sp->dest!=NULL)
	free((void *) sp->dest);
    r=l->refs;
    while (r!=NULL)
    {
	nr=r->next;
	free((void *) r);
	r=nr;
    }
    free(sp);
}

/* Append s2 to *s1 */
void socklist_append(socklist **s1, socklist *s2)
{
    socklist *scan, **scanp;

    scanp=s1;
    scan=*s1;
    while (scan!=NULL)
    {
	scanp=&(scan->next);
	scan=scan->next;
    }
    *scanp=s2;
}


#if 0
/* Remove all items in both s1 and s2 from both lists */
void socklist_diff(__sock_list **s1, __sock_list **s2)
{
    __sock_list **linkp, *scan, *n;
    
    linkp=s1;
    scan=*s1;
    while(scan!=NULL)
    {
	if (socklist_remove(s2, scan))
	{
	    /* Item was present, remove it from s1 too */
	    n=scan->next;
	    *linkp=n;
	    free_sock(scan);
	    scan=n;
	}
	else
	{
	    linkp=&(scan->next);
	    scan=scan->next;
	}
    }
}
#endif
