/* $Id: numbuf.h,v 1.1.1.1 2000/05/04 22:54:51 dps Exp $ */
/* Expandable number buffer */

#ifndef ___CPS_NUMBUF_H___
#define ___CPS_NUMBUF_H___ 1

typedef struct
{
    int *nums;
    int max;
    int pos;
} numbuf;

extern int expand_buf(numbuf *n);
extern numbuf *allocate(void);
extern void empty_nums(numbuf *n);
extern void free_nums(numbuf *n);

#ifdef ___CPS__NUMBUF_CONFIG
/* Maximum numbers to support (anti-DoS measure) */
#define MAXX_NUMS 10000

/* Initial buffer size */
#define INITIAL_NUMS 200

/* Incremenets in buffer size*/	
#define INC 50
#endif /* ___NUMBUF_CONFIG */

#endif /* ___CPS_NUMBUF_H___ */
